/* 
  Crazy Crane
  Grzegorz Kraszewski, 2013.
  Time counter routines.
*/

#ifndef CRAZYCRANE_COUNTER_H
#define CRAZYCRANE_COUNTER_H

#define __USE_OLD_TIMEVAL__

#include <devices/timer.h>


#ifndef TARGET_AMIGAOS4

struct TimeVal
{
	ULONG Seconds;
	ULONG Microseconds;
};

struct TimeRequest
{
	struct IORequest Request;
	struct TimeVal Time;
};

#endif


struct Counter
{
	struct Library *TimerBase;
	#ifdef TARGET_AMIGAOS4
	struct TimerIFace *ITimer;
	#endif
	struct MsgPort *Port;
	struct TimeRequest *Req;
	struct EClockVal NextTick;
	ULONG EClockFreq;
	ULONG ETick;                     // precalculated tick length in eclocks
};


BOOL CounterNew(struct Counter *c);
void CounterDispose(struct Counter *c);
void CounterRetrig(struct Counter *c);

#endif /* CRAZYCRANE_COUNTER_H */
